////////////////////////////////////////////////////////////////////////////////
// Copyright (C) 1998 by Thierry Maurel
// All rights reserved
//
// Distribute freely, except: don't remove my name from the source or
// documentation (don't take credit for my work), mark your changes (don't
// get me blamed for your possible bugs), don't alter or remove this
// notice.
// No warrantee of any kind, express or implied, is included with this
// software; use at your own risk, responsibility for damages (if any) to
// anyone resulting from the use of this software rests entirely with the
// user.
//
// Send bug reports, bug fixes, enhancements, requests, flames, etc., and
// I'll try to keep a version up to date.  I can be reached as follows:
//    tmaurel@caramail.com   (or tmaurel@hol.fr)
//
////////////////////////////////////////////////////////////////////////////////
// File    : AccelMapPage.h
// Project : AccelsEditor
////////////////////////////////////////////////////////////////////////////////
// Version : 1.0                       * Author : T.Maurel
// Date    : 17.08.98
//
// Remarks : Same def as in CAccelMapDlg sources, but for a propertypage...
//
////////////////////////////////////////////////////////////////////////////////
#if !defined(AFX_ACCELMAPPAGE_H__14910613_3284_11D2_BE80_006097AC8D00__INCLUDED_)
#define AFX_ACCELMAPPAGE_H__14910613_3284_11D2_BE80_006097AC8D00__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


#include "AccelDlgHelper.h"
#include "AcceleratorManager.h"
#include "AccelListBox.h"
#include "KeyboardEdit.h"


/////////////////////////////////////////////////////////////////////////////
// CAccelMapPage dialog

class CAccelMapPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CAccelMapPage)

// Construction
public:
	CAccelMapPage(CAcceleratorManager* pAccelManager = NULL);
	~CAccelMapPage();

// Dialog Data
	//{{AFX_DATA(CAccelMapPage)
	enum { IDD = IDD_EDIT_ACCELMAP };
	CStatic	m_AlreadyAffected;
	CKeyboardEdit	m_Key;
	CAccelListBox	m_Currents;
	CListBox	m_Commands;
	//}}AFX_DATA

protected:
	CAcceleratorManager* m_pAccelManager;
	CAccelDlgHelper m_helper;

// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CAccelMapPage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void InitCommands();

	// Generated message map functions
	//{{AFX_MSG(CAccelMapPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnAssign();
	afx_msg void OnRemove();
	afx_msg void OnReset();
	afx_msg void OnSelChangeCommands();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ACCELMAPPAGE_H__14910613_3284_11D2_BE80_006097AC8D00__INCLUDED_)
