/////////////////////////////////////////////////////////////////////////////
//

// AccelsEditor.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "AccelsEditor.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "AccelsEditorDoc.h"
#include "AccelsEditorView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAccelsEditorApp

BEGIN_MESSAGE_MAP(CAccelsEditorApp, CWinApp)
	//{{AFX_MSG_MAP(CAccelsEditorApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAccelsEditorApp construction/destruction
/////////////////////////////////////////////////////////////////////////////
//
//
CAccelsEditorApp::CAccelsEditorApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


/////////////////////////////////////////////////////////////////////////////
//
//
CAccelsEditorApp::~CAccelsEditorApp()
{
#ifdef _DEBUG
	m_AccelManager.Dump(afxDump);
#endif
}


/////////////////////////////////////////////////////////////////////////////
// The one and only CAccelsEditorApp object

CAccelsEditorApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CAccelsEditorApp initialization

BOOL CAccelsEditorApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Thierry Maurel Applications"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_ACCELSTYPE,
		RUNTIME_CLASS(CAccelsEditorDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CAccelsEditorView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	
////////////////////////////////////////////////////////////////////////////////////
// ##CAcceleratorManager adding
//
	////////////////////////////////////////////////////////////////////////////////////
	// Connect the manager to the main frame. This fct set the AutSave flag to true
	m_AccelManager.Connect(pMainFrame);

	// The default changes (and others) must be
	// followed by UpdateWndTable().
	
	// Create a locked accelerator for 'ID_TEST_ACCEL' (handler in CDocument)
	m_AccelManager.SetAccel(FSHIFT | FVIRTKEY,
							ID_TEST_ACCEL,
							WORD(_T('A')),
							_T("Test"),
							true);

	// Create a dafault non-locked accelerator for 'ID_TEST_ACCEL'
	m_AccelManager.SetAccel(FSHIFT | FVIRTKEY,
							ID_TEST_ACCEL,
							WORD(_T('Z')),
							_T("Test"),
							false);

	// Associate resource accelerators with 'command strings'
	m_AccelManager.AddCommandAccel(ID_FILE_NEW, _T("FileNew"));
	m_AccelManager.AddCommandAccel(ID_FILE_OPEN, _T("FileOpen"));

	// Create an empty 'command string'. The User can edit it in
	// the CDialog or the CPropertyPage.
	m_AccelManager.CreateEntry(ID_APP_ABOUT,  _T("About"));

	// Update the wnd's ACCEL table, based on the datas
	// contained in the m_AccelManager.
	m_AccelManager.UpdateWndTable();

	// Enable the 'Reset All' possibility.
	m_AccelManager.CreateDefaultTable();

	// You can choice any key in the registry, the user accels will
	// be save in the 'Keyboard' value, at the specified key.
	CString strKey = _T("Software\\");
	strKey += m_pszRegistryKey;
	strKey += _T("\\");
	strKey += m_pszAppName;
	strKey += _T("\\Settings");

	// Load the precedents users accels, it will erase/update the defaults user's.
	if (m_AccelManager.Load(HKEY_CURRENT_USER, strKey) == false)
		AfxMessageBox("Loading User accelerators failed !!");
/////////////////////////////////////////////////////////////////////////////

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CAccelsEditorApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CAccelsEditorApp commands
