// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "AccelsEditor.h"

#include "MainFrm.h"
#include "AccelMapDlg.h"
#include "AccelMapPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_TEST_ADD, OnTestAdd)
	ON_COMMAND(ID_TEST_EDIT_DLG, OnTestEditDlg)
	ON_COMMAND(ID_TEST_EDIT_PAGE, OnTestEditPage)
	ON_COMMAND(ID_TEST_GETSTRINGFROMACCEL, OnTestGetStringFromAccel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_bShift = true;
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CMDIFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG



/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
/////////////////////////////////////////////////////////////////////////////
//
//
void CMainFrame::OnTestAdd() 
{
// ##CAcceleratorManager adding
	// Add or Change
	CString szBufferAbout = "";
	CString szBufferTest = "";
	CString szGetString;
	CAcceleratorManager tmpAccelManager;

	WORD nCode = (WORD)(rand() % 26 + 65);
	BYTE cVirt;
	if (m_bShift)
		cVirt = FSHIFT | FVIRTKEY;
	else
		cVirt = FCONTROL | FVIRTKEY;

	if (((CAccelsEditorApp*)AfxGetApp())->m_AccelManager.SetAccel(cVirt,
																ID_APP_ABOUT,
																nCode,
																_T("About")) == true) {
		tmpAccelManager.GetStringFromACCEL(cVirt, nCode, szGetString);
		
		szBufferAbout.Format("New accel for About : %s", szGetString);
	} else
		szBufferAbout = "No change for About...";
	nCode = (WORD)(rand() % 26 + 65);
	if (m_bShift)
		cVirt = FCONTROL | FVIRTKEY;
	else
		cVirt = FSHIFT | FVIRTKEY;
		
	if (((CAccelsEditorApp*)AfxGetApp())->m_AccelManager.SetAccel(cVirt,
																ID_TEST_ACCEL,
																nCode,
																_T("Test")) == true) {
		tmpAccelManager.GetStringFromACCEL(cVirt, nCode, szGetString);
		szBufferTest.Format("\nNew accel for Test : %s", szGetString);
	} else
		szBufferTest = "\nNo change for Test...";

	((CAccelsEditorApp*)AfxGetApp())->m_AccelManager.UpdateWndTable();
	MessageBox(szBufferAbout + szBufferTest, "Adding/Change random accels");

	m_bShift = !m_bShift;
}


/////////////////////////////////////////////////////////////////////////////
//
//
void CMainFrame::OnTestEditDlg() 
{
// ##CAcceleratorManager adding
	// Accels edition with Dialog
	CAcceleratorManager tmpAccelManager;
	tmpAccelManager = ((CAccelsEditorApp*)AfxGetApp())->m_AccelManager;
	CAccelMapDlg dlg(&tmpAccelManager);
	if (dlg.DoModal() == IDOK) {
		((CAccelsEditorApp*)AfxGetApp())->m_AccelManager = tmpAccelManager;
		((CAccelsEditorApp*)AfxGetApp())->m_AccelManager.UpdateWndTable();
	}
}


/////////////////////////////////////////////////////////////////////////////
//
//
void CMainFrame::OnTestEditPage() 
{
// ##CAcceleratorManager adding
	// Accels edition with PropertyPage 
	CAcceleratorManager tmpAccelManager;
	tmpAccelManager = ((CAccelsEditorApp*)AfxGetApp())->m_AccelManager;
	CAccelMapPage page(&tmpAccelManager);
	CPropertySheet sheet;
	sheet.AddPage(&page);
	if (sheet.DoModal() == IDOK) {
		((CAccelsEditorApp*)AfxGetApp())->m_AccelManager = tmpAccelManager;
		((CAccelsEditorApp*)AfxGetApp())->m_AccelManager.UpdateWndTable();
	}
}


/////////////////////////////////////////////////////////////////////////////
//
//
void CMainFrame::OnTestGetStringFromAccel() 
{
// ##CAcceleratorManager adding
	// Get the string from an ACCEL definition.
	ACCEL accel;
	accel.key = (WORD)(rand() % 26 + 65);
	if (m_bShift)
		accel.fVirt = FSHIFT | FVIRTKEY;
	else
		accel.fVirt = FCONTROL | FVIRTKEY;
	accel.cmd = 0; // not used in the fct GetStringFromACCEL

	CString szBuffer, szString;
	CAcceleratorManager tmpAccelManager;
	tmpAccelManager.GetStringFromACCEL(&accel, szString);
	szBuffer.Format("Parameter contains { %s, '%c' },\nand the returned string is ",
					m_bShift ? "FSHIFT" : "FCONTROL",
					accel.key);
	AfxMessageBox(szBuffer + szString);
	m_bShift = !m_bShift;
}


